#include "fusion.h"
#include <stdlib.h>
#include "es.h"

tableau *cree_tableau(int taille){
  tableau *t = (tableau *)malloc(sizeof(tableau));
  t->n = taille;
  t->coeff = (int *) malloc(sizeof(int) * taille);
  
  return t;
}

tableau *copie_tableau(tableau *t){
  int i;
  tableau *tcopy = cree_tableau(t->n);
  for(i=0; i<t->n; i++)
    tcopy->coeff[i] = t->coeff[i];

  return tcopy;
}

tableau *sous_tableau(tableau *t, int s, int e){
  int i;
  tableau *soustableau;
  if((s<0) || (e>t->n))
    return NULL;
  soustableau = cree_tableau(e-s);
  for(i=0; i<e-s; i++)
    soustableau->coeff[i] = t->coeff[s+i];

  return soustableau;
}

void detruit_tableau(tableau *t){
  free(t->coeff);
  free(t);
}

tableau *fusionne_tableau(tableau *final, tableau *tab1, tableau *tab2){
  int i1=0, i2=0;
  while(i1<tab1->n || i2<tab2->n){
    if(i2 == tab2->n || (i1<tab1->n && tab1->coeff[i1] <= tab2->coeff[i2])){
      final->coeff[i1+i2] = tab1->coeff[i1];
      i1 ++;
    }else{
      final->coeff[i1+i2] = tab2->coeff[i2];
      i2 ++;
    }
    
  }
  return final;
}

tableau *tri_tableau(tableau *t){
  int m;
  tableau *tab1, *tab2;
  if(t == NULL)
    return NULL;

  if(t->n == 1)
    return t;
  
  m = t->n / 2;
  tab1 = sous_tableau(t, 0, m);
  tab2 = sous_tableau(t, m, t->n);
  tri_tableau(tab1);
  tri_tableau(tab2);
  fusionne_tableau(t, tab1, tab2);
  detruit_tableau(tab1);
  detruit_tableau(tab2);
  
  return t;
}
