#ifndef __FUSION__
#define __FUSION__

typedef struct{
	int n;
	int *coeff;
} tableau;

/* cree un pointeur sur un tableau dont la taille */
/* est specifiee en parametre                     */
tableau *cree_tableau(int taille);

/* cree un pointeur sur un tableau dont les elements */
/* sont copies du tableau pointe par t               */
tableau *copie_tableau(tableau *t);

/* cree un pointeur sur un tableau dont les elements          */
/* sont les elements d'indice s a e-1 du tableau pointe par t */
tableau *sous_tableau(tableau *t, int s, int e);

/* libere la memoire utilisee par t */
void     detruit_tableau(tableau *t);

/* fusionne les elements de t1 et t2 (en conservant l'ordre) et */
/* les place dans le tableau pointe par le parametre 'final'.   */
/* renvoie 'final'                                              */
tableau *fusionne_tableau(tableau *final, tableau *t1, tableau *t2);

/* effectue le tri du tableau t, qui est modifie. renvoie t */
tableau *tri_tableau(tableau *t);

#endif

